var BingLayer = L.TileLayer.extend({

    getTileUrl: function (tilePoint)
    {
        this._adjustTilePoint(tilePoint);
        
        return L.Util.template(this._url, {
            s: this._getSubdomain(tilePoint),
            q: this._quadKey(tilePoint.x, tilePoint.y, this._getZoomForUrl())
        });
    },

    _quadKey: function (x, y, z)
    {
        var quadKey = [];

        for (var i = z; i > 0; i--)
        {
            var digit = '0';
            var mask = 1 << (i - 1);

            if ((x & mask) != 0)
            {
                digit++;
            }
            
            if ((y & mask) != 0)
            {
                digit++;
                digit++;
            }

            quadKey.push(digit);
        }

        return quadKey.join('');
    }
});